$(document).ready(function() {
    var chat_last_i = 0;
    var chat_window = $(".quest_chat");
    var chat = $(".quest_chat-holder");
    var alter_actions = new Array();
    var userAnswers = []; 

    function get_time() {
        var today = new Date();
        var hours = today.getHours();
        var minutes = today.getMinutes();

        if (minutes <= 9) {
            minutes = "0" + minutes;
        }
        if (hours <= 9) {
            hours = "0" + hours;
        }

        return hours + ":" + minutes;
    }

    function pull_message(message) {
        if (!message) {
            return; // Exit the function if message is undefined or null
        }

        if (
            message.if !== undefined &&
            message.if === "quest_after_form_flag" &&
            typeof quest_after_form_flag === "undefined"
        ) {
            chat_last_i++;
            continue_chat();
            return;
        }

        var additional_class =
            message !== undefined && message.c !== undefined ? message.c : "";
        chat.append(
            '<div class="quest_chat-message ' +
            message.t +
            " " +
            additional_class +
            ' active empty"><div class="loader dot-falling"></div></div><div class="clear_both"></div>'
        );
        var message_content = "";
        if (message.t === "buttons") {
            for (var i = 0; i < message.items.length; i++) {
                var b_id = chat_last_i + "_" + i;
                var button_additional_class =
                    message.items[i].c !== undefined ? message.items[i].c : "";
                var icon =
                    message.items[i].i !== undefined ?
                    '<img class="icon" src="./img/' + message.items[i].i + '">' :
                    "";
                message_content +=
                    "<div class='quiz-btn-wrapper'>" +
                    '<input type="radio" name="' +
                    chat_data[chat_last_i - 1].m +
                    '" value="' +
                    message.items[i].m +
                    '" id="' +
                    b_id +
                    '">' +
                    '<label for="' +
                    b_id +
                    '" class="' +
                    button_additional_class +
                    '" ' +
                    'data-action="' +
                    message.items[i].action +
                    '" ' +
                    'data-button="' +
                    message.items[i].button +
                    '" ' +
                    'data-text="' +
                    message.items[i].text +
                    '"' +
                    'data-chat="' +
                    message.items[i].chat +
                    '"' +
                    'data-item="' +
                    message.items[i].item +
                    '"' +
                    'data-if="' +
                    message.items[i].if +
                    '"' +
                    ">" +
                    message.items[i].m +
                    icon +
                    "</label></div>";
            }
            $(".quest_chat-message.empty")
                .html(message_content)
                .addClass("display_none")
                .removeClass("empty")
                .slideDown();

            const btns = document.querySelectorAll(
                ".display_none.active input[type=radio]"
            );

            btns.forEach((btn) => {
                btn.addEventListener("click", () => {
                    const question = btn.name;
                    const answer = btn.value;

                    userAnswers.push({
                        question,
                        answer,
                    });

                    // Update the hidden input field with the serialized userAnswers
                    $("#comment").val(JSON.stringify(userAnswers));
                });
            });

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
            }, 150);

            if (message.no_increment !== true) {
                chat_last_i++;
            }
        } else if (message.t === "input_birth_date") {
            var b_id = chat_last_i + "_birth_date";
            message_content +=
                '<div><input class="' +
                message.t +
                '" type="number" id="' +
                b_id +
                '" name="' +
                chat_data[chat_last_i - 1].m +
                '" value=""></div>';

            $(".quest_chat-message.empty")
                .html(message_content)
                .addClass("display_none user")
                .removeClass("empty")
                .slideDown();
            var birth_input = $("#" + b_id);
            birth_input.focus();

            birth_input.on("keyup blur", function() {
                birth_input.removeClass("error");
                var len = birth_input.val().length;
                if (len === 4) {
                    if (birth_input.val() < 1900 || birth_input.val() > 2022) {
                        birth_input.addClass("error");
                    } else {
                        if (birth_input.val() > message.max) {
                            message.m = message.text;
                            show_exit_chat(message);
                        } else {
                            chat_last_i++;
                            birth_input
                                .attr("readonly", true)
                                .off("keyup blur")
                                .addClass("confirmed")
                                .attr("type", "text");

                            // Store birth date answer
                            userAnswers.push({
                                question: birth_input.attr("name"),
                                answer: birth_input.val(),
                            });

                            // Update the hidden input field with the serialized userAnswers
                            $("#comment").val(JSON.stringify(userAnswers));

                            continue_chat();
                        }
                    }
                }
            });
        } else if (message.t === "user") {
            message_content +=
                message.m + '<div class="quest_chat-t">' + get_time() + "</div>";
            $(".quest_chat-message.empty").html(message_content).removeClass("empty");
            if (message.no_continue !== true) {
                continue_chat();
            }
        } else if (message.t === "image") {
            message_content +=
                '<div class="img"><img src="./img/' +
                message.src +
                '"></div><div class="title">' +
                message.h +
                '</div><div class="body">' +
                message.m +
                "</div>";
            $(".quest_chat-message.empty").html(message_content).removeClass("empty");

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
            }, 150);

            chat_last_i++;
            continue_chat();
        } else if (message.t === "analyze") {
            message_content +=
                '<div class="circular">\n' +
                '    <div class="circular_inner"></div>\n' +
                '    <div class="circular_number">0%</div>\n' +
                '    <div class="circular_circle">\n' +
                '        <div class="circular_bar circular_left">\n' +
                '            <div class="circular_progress"></div>\n' +
                "        </div>\n" +
                '        <div class="circular_bar circular_right">\n' +
                '            <div class="circular_progress"></div>\n' +
                "        </div>\n" +
                "    </div>\n" +
                "</div>";
            message_content += '<div class="title">' + message.h + "</div>";

            message_content += "<ul>";
            for (var i = 0; i < message.items.length; i++) {
                message_content +=
                    '<li class="inactive"><div class="analyze-spinner"><div class="lds-ring"><div></div><div></div><div></div><div></div></div></div>' +
                    message.items[i].m +
                    "</li>";
            }
            message_content += "</ul>";
            $(".quest_chat-message.empty")
                .html(message_content)
                .addClass("display_none")
                .removeClass("empty")
                .slideDown();

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
                start_circle_progress();
            }, 150);
            chat_last_i++;
        } else if (message.t === "summary") {
            message_content += '<div class="summary-items">';
            message_content += '<div class="title">' + message.h + "</div>";
            for (var i = 0; i < message.items.length; i++) {
                message_content +=
                    '<div class="item">' +
                    '<div class="item-h">' +
                    message.items[i].h +
                    "</div>" +
                    '<div class="item-progress">' +
                    '<div class="item-bar  item-bar-' +
                    i +
                    '">' +
                    '<div class="bar_holder"></div>' +
                    '<div class="bar" data-w="' +
                    message.items[i].w +
                    '"></div>' +
                    "</div>\n" +
                    '<div class="item-s">' +
                    message.items[i].s +
                    "</div>\n" +
                    "</div>\n" +
                    '<div class="item-m">' +
                    message.items[i].m +
                    "</div>";
                ("</div>\n");
            }
            message_content += "</div>";

            $(".quest_chat-message.empty")
                .html(message_content)
                .addClass("display_none")
                .removeClass("empty")
                .slideDown();

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );

                $(".summary .bar").each(function() {
                    $(this).animate({
                            width: $(this).data("w") + "%",
                        },
                        $(this).data("w") * 3
                    );
                });
            }, 150);

            chat_last_i++;

            setTimeout(function() {
                continue_chat();
            }, 3000);
        } else if (message.t === "score") {
            message_content +=
                '<div class="title">' +
                message.h +
                ' <span class="percents">' +
                message.s +
                "</span></div>";
            message_content +=
                '<div class="information"><img src="./img/lamp.png"> <span>' +
                message.i +
                "</span></div>";
            message_content += '<div class="message">' + message.m + "</div>";

            $(".quest_chat-message.empty")
                .html(message_content)
                .addClass("display_none")
                .removeClass("empty")
                .slideDown();

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
            }, 150);
            chat_last_i++;
            setTimeout(function() {
                continue_chat();
            }, 1500);
        } else if (message.t === "title") {
            message_content += '<div class="title">' + message.h + "</div>";
            $(".quest_chat-message.empty").html(message_content).removeClass("empty");

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
            }, 150);

            chat_last_i++;
            continue_chat();
        } else if (message.t === "subtitle") {
            message_content += '<div class="subtitle">' + message.h + "</div>";
            $(".quest_chat-message.empty").html(message_content).removeClass("empty");

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
            }, 150);

            chat_last_i++;
            continue_chat();
        } else if (message.t === "text") {
            message_content += '<div class="text">' + message.h + "</div>";
            $(".quest_chat-message.empty").html(message_content).removeClass("empty");

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
            }, 150);

            chat_last_i++;
            continue_chat();
        } else {
            //bot
            if (message.m !== undefined) {
                $(".quest_chat-message").not(".empty").removeClass("active");
                message_content +=
                    message.m + '<div class="quest_chat-t">' + get_time() + "</div>";
                var timeout = message.m.length * 12 + 900;
                setTimeout(function() {
                    $(".quest_chat-message.empty")
                        .html(message_content)
                        .removeClass("empty");
                    if (message.action !== undefined && message.action == "go_to") {
                        pull_message(alter_chat[message.chat][message.item]);
                        return;
                    } else {
                        chat_last_i++;
                        continue_chat();
                    }
                }, timeout);
            }

            setTimeout(function() {
                $(chat).animate({
                        scrollTop: chat[0].scrollHeight,
                    },
                    500
                );
            }, 150);
        }
    }

    function continue_chat() {
        var message = chat_data[chat_last_i];
        pull_message(message);
    }

    function show_exit_chat(message) {
        var exit_message =
            '<div class="quest_chat-exit-holder"><div class="text">' +
            message.m +
            '</div><div><button class="btn btn-submit text-uppercase quest_chat-exit ' +
            message.action +
            '"><span>' +
            message.button +
            "</span></button></div></div>";

        chat.addClass("no-scroll");
        chat.find("div").hide();
        chat.append(exit_message);
    }

    //Click on button close chat
    $(document).on("click", ".quest_chat-exit", function(e) {
        e.preventDefault();
        if ($(this).hasClass("exit")) {
            chat.html("");
        }
        if ($(this).hasClass("finish")) {
            $(".quest_or_form").toggle();
        }
        chat_window.fadeOut(300);
        $("body").removeClass("no-scroll");
        window.postMessage({
                eventName: "onResume",
            },
            "*"
        );
    });

    // Click on button in chat
    $(document).on("click", ".quest_chat-message.buttons label", function() {
        // go_to with if. If there's "if" and "if" is false, continue chat as usual
        if ($(this).data("if") !== "undefined") {
            let if_arr = $(this).data("if").split(","); // collection of "if" in button
            let if_cond = true;
            if_arr.forEach((element) => {
                if (!alter_actions.includes(element)) {
                    if_cond = false;
                }
            });
            if (!if_cond) {
                $(this).data("action", "0");
            }
        }

        if (
            $(this).data("action") === "exit" ||
            $(this).data("action") === "finish"
        ) {
            message = {
                action: $(this).data("action"),
                button: $(this).data("button"),
                m: $(this).data("text"),
            };
            show_exit_chat(message);
        } else if ($(this).data("action") === "continue") {
            $(this).closest(".quest_chat-message.buttons").slideUp();
            $(this)
                .closest(".quest_chat-message.buttons")
                .prev()
                .css("height", "15px");
            continue_chat();
        } else if ($(this).data("action") === "go_to") {
            alter_actions.push("" + $(this).data("chat") + "");
            $(this).closest(".quest_chat-message.buttons").slideUp();
            message = {
                t: "user",
                m: $(this).html(),
                no_continue: true,
            };
            pull_message(message);
            chat_calculate_summary();
            pull_message(alter_chat[$(this).data("chat")][$(this).data("item")]);
        } else if ($(this).data("action") === "show_form") {
            var formHtml = $("#embedded-form").clone().show().html();
            message = {
                t: "user",
                m: $(this).html(),
            };
            pull_message(message);
            $(this).closest(".quest_chat-message.buttons").slideUp();
            $(".quest_chat-holder").append('<div class="quest_chat-message bot active">' + formHtml + '</div>');
            continue_chat();
        } else {
            $(this).closest(".quest_chat-message.buttons").slideUp();
            if ($(this).find(".icon")) {
                $(this).find(".icon").remove();
            }
            message = {
                t: "user",
                m: $(this).html(),
            };
            pull_message(message);
            chat_calculate_summary();
        }

        // console.log($('#comment').val());

    });


    $(".btn-show-quest").on("click", function(e) {
        e.preventDefault();
        window.postMessage({
                eventName: "onPause",
            },
            "*"
        );
        $("body").addClass("no-scroll");
        chat.removeClass("no-scroll").html("");

        chat_window.show();
        chat_last_i = 0;
        chat_calculate_summary();
        continue_chat();
    });
    

    function chat_calculate_summary() {
        if ($(".quest_chat-indicators").is("div")) {
            var _first_all =
                (_second_all =
                    _all =
                    _first_done =
                    _second_done =
                    _done =
                    0);
            for (var item in chat_data) {
                if (chat_data[item].i_first === true) {
                    _first_all++;
                }
                if (chat_data[item].i_second === true) {
                    _second_all++;
                }

                if (item < chat_last_i && chat_data[item].i_first === true) {
                    _first_done++;
                }

                if (item < chat_last_i && chat_data[item].i_second === true) {
                    _second_done++;
                }
            }

            _all = _first_all + _second_all;
            _done = _first_done + _second_done;

            if ($(".summary-done").html(_done));
            if ($(".summary-all").html(_all));

            var _first_width = Math.round((_first_done * 100) / _first_all);
            var _second_width = Math.round((_second_done * 100) / _second_all);

            $(".bar-first").css("width", _first_width + "%");
            $(".bar-second").css("width", _second_width + "%");
        }
    }

    function start_circle_progress() {
        const numb = document.querySelector(".circular_number");
        let counter = 0;
        let _time = 74;
        setInterval(() => {
            if (counter == 100) {
                clearInterval();
            } else {
                counter += 1;
                numb.textContent = counter + "%";
            }
        }, _time);

        if ($(".analyze .inactive").is("li")) {
            let _time_each_li = (_time * 100) / $(".analyze li").length;
            $(".analyze li.inactive").each(function(_i) {
                var _this = $(this);
                setTimeout(function() {
                    _this.removeClass("inactive");
                    _this.addClass("active");
                }, (_i + 1 * 0.9) * _time_each_li);
            });
        }

        setTimeout(function() {
            continue_chat();
        }, _time * 100 + 300);
    }
});
